#!/usr/bin/env bash

#phys-458	KaaS Management cluster
#	vm-41
#	vm-42
#	vm-43
#	Managed cluster - control plane
#	vm-44
#	vm-45
#	vm-46
#	Managed cluster - ceph
#	vm-47
#	vm-48
#	vm-49
#	Managed cluster - stacklight
#	vm-50
#	vm-51
#	vm-52
#	Managed cluster - worker/storage
# vm-53
# vm-54
# vm-55
# vm-56
# vm-57
# vm-58
# vm-59
# vm-60
echo 'set_power' \

ipmi_password="password"

function set_power(){
  local action=${1:-'status'}   # "off" to shutdown
  local nset=${2:-'all'}

  declare -A nodes
  declare -A ports

  declare -A nodes_mgmt=(
    [vm-41]='172.18.168.13' \
    [vm-42]='172.18.168.13' \
    [vm-43]='172.18.168.13'
  )
  declare -A ports_mgmt=(
    [vm-41]='10041' \
    [vm-42]='10042' \
    [vm-43]='10043'
  )

  declare -A nodes_child=(
    [vm-44]='172.18.168.13' \
    [vm-45]='172.18.168.13' \
    [vm-45]='172.18.168.13' \
    [vm-47]='172.18.168.13' \
    [vm-48]='172.18.168.13' \
    [vm-49]='172.18.168.13' \
    [vm-50]='172.18.168.13' \
    [vm-51]='172.18.168.13' \
    [vm-52]='172.18.168.13' \
    [vm-53]='172.18.168.13' \
    [vm-54]='172.18.168.13' \
    [vm-55]='172.18.168.13' \
    [vm-56]='172.18.168.13' \
    [vm-57]='172.18.168.13' \
    [vm-58]='172.18.168.13' \
    [vm-59]='172.18.168.13' \
    [vm-60]='172.18.168.13'
  )
  declare -A ports_child=(
    [vm-44]='10044' \
    [vm-45]='10045' \
    [vm-45]='10046' \
    [vm-47]='10047' \
    [vm-48]='10048' \
    [vm-49]='10049' \
    [vm-50]='10050' \
    [vm-51]='10051' \
    [vm-52]='10052' \
    [vm-53]='10053' \
    [vm-54]='10054' \
    [vm-55]='10055' \
    [vm-56]='10056' \
    [vm-57]='10057' \
    [vm-58]='10058' \
    [vm-59]='10059' \
    [vm-60]='10060'
  )

  # awesome merge event...
  case "$nset" in
      'mgmt')
        for i in ${!nodes_mgmt[@]}; do
            nodes[$i]="${nodes_mgmt[$i]}"
        done
        for i in ${!ports_mgmt[@]}; do
            ports[$i]="${ports_mgmt[$i]}"
        done
      ;;
      'child')
        for i in ${!nodes_child[@]}; do
            nodes[$i]="${nodes_child[$i]}"
        done
        for i in ${!ports_child[@]}; do
            ports[$i]="${ports_child[$i]}"
        done
      ;;
      'all')
        for i in ${!nodes_child[@]}; do
            nodes[$i]="${nodes_child[$i]}"
        done
        for i in ${!nodes_mgmt[@]}; do
            nodes[$i]="${nodes_mgmt[$i]}"
        done
        for i in ${!ports_child[@]}; do
            ports[$i]="${ports_child[$i]}"
        done
        for i in ${!ports_mgmt[@]}; do
            ports[$i]="${ports_mgmt[$i]}"
        done
      ;;
  esac

  for i in "${!nodes[@]}"; do
    echo "node: $i"
    set -xe
    ipmitool -I lanplus -H ${nodes[$i]} -p ${ports[$i]} -U admin -P "${ipmi_password}" chassis power $action
    set +xe
  done
 }

