from si_tests.deployments import deploy_refapp
from si_tests.lcm import openstack_lcm


def test_update_os_controller_simple(os_manager):
    """Update OS Controller.
       Parameters required for test execution:
         - KUBECONFIG
         - OSH_OPERATOR_UPDATE_REPO
         - OSH_OPERATOR_UPDATE_TAG
         - OSH_OPERATOR_CHART_URL
         - OSH_OPERATOR_CHART_VERSION
    """

    openstack_lcm.update_os_controller(os_manager)


def test_update_os_controller_with_refapp(os_manager,
                                          openstack_client_manager):
    """Update OS Controller with refapp tests.
    1) Deploy RefApp
    2) Check RefApp workability before update
    3) Update OpenStack controller
    4) Check RefApp workability after update
    5) Delete RefApp

       Parameters required for test execution:
         - KUBECONFIG
         - OSH_OPERATOR_UPDATE_REPO
         - OSH_OPERATOR_UPDATE_TAG
         - OSH_OPERATOR_CHART_URL
         - OSH_OPERATOR_CHART_VERSION
    """

    deploy_refapp.deploy_refapp(openstack_client_manager)
    openstack_lcm.check_refapp(openstack_client_manager)
    openstack_lcm.update_os_controller(os_manager)
    openstack_lcm.check_refapp(openstack_client_manager)
    deploy_refapp.delete_refapp(openstack_client_manager)
